# coding: utf-8

"""
    DOJAH Publilc APIs

    Use Dojah to verify, onboard and manage user identity across Africa!

    The version of the OpenAPI document: 1.0.0
    Generated by: https://konfigthis.com
"""

from dataclasses import dataclass
import typing_extensions
import urllib3
from dojah_client.request_before_hook import request_before_hook
import json
from urllib3._collections import HTTPHeaderDict

from dojah_client.api_response import AsyncGeneratorResponse
from dojah_client import api_client, exceptions
from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from dojah_client import schemas  # noqa: F401

from dojah_client.model.aml_screen_aml_response import AmlScreenAmlResponse as AmlScreenAmlResponseSchema
from dojah_client.model.aml_screen_aml_request import AmlScreenAmlRequest as AmlScreenAmlRequestSchema

from dojah_client.type.aml_screen_aml_response import AmlScreenAmlResponse
from dojah_client.type.aml_screen_aml_request import AmlScreenAmlRequest

from . import path

# body param
SchemaForRequestBodyApplicationJson = AmlScreenAmlRequestSchema


request_body_aml_screen_aml_request = api_client.RequestBody(
    content={
        'application/json': api_client.MediaType(
            schema=SchemaForRequestBodyApplicationJson),
    },
    required=True,
)
_auth = [
    'apikeyAuth',
    'appIdAuth',
]
AccessControlAllowOriginSchema = schemas.StrSchema
access_control_allow_origin_parameter = api_client.HeaderParameter(
    name="Access-Control-Allow-Origin",
    style=api_client.ParameterStyle.SIMPLE,
    schema=AccessControlAllowOriginSchema,
)
XMoesifTransactionIdSchema = schemas.StrSchema
x_moesif_transaction_id_parameter = api_client.HeaderParameter(
    name="x-moesif-transaction-id",
    style=api_client.ParameterStyle.SIMPLE,
    schema=XMoesifTransactionIdSchema,
)
ServiceSchema = schemas.StrSchema
service_parameter = api_client.HeaderParameter(
    name="service",
    style=api_client.ParameterStyle.SIMPLE,
    schema=ServiceSchema,
)
ProductSchema = schemas.StrSchema
product_parameter = api_client.HeaderParameter(
    name="product",
    style=api_client.ParameterStyle.SIMPLE,
    schema=ProductSchema,
)
PriceSchema = schemas.IntSchema
price_parameter = api_client.HeaderParameter(
    name="price",
    style=api_client.ParameterStyle.SIMPLE,
    schema=PriceSchema,
)
ContentLengthSchema = schemas.IntSchema
content_length_parameter = api_client.HeaderParameter(
    name="Content-Length",
    style=api_client.ParameterStyle.SIMPLE,
    schema=ContentLengthSchema,
)
ETagSchema = schemas.StrSchema
e_tag_parameter = api_client.HeaderParameter(
    name="ETag",
    style=api_client.ParameterStyle.SIMPLE,
    schema=ETagSchema,
)
VarySchema = schemas.StrSchema
vary_parameter = api_client.HeaderParameter(
    name="Vary",
    style=api_client.ParameterStyle.SIMPLE,
    schema=VarySchema,
)
DateSchema = schemas.StrSchema
date_parameter = api_client.HeaderParameter(
    name="Date",
    style=api_client.ParameterStyle.SIMPLE,
    schema=DateSchema,
)
ConnectionSchema = schemas.StrSchema
connection_parameter = api_client.HeaderParameter(
    name="Connection",
    style=api_client.ParameterStyle.SIMPLE,
    schema=ConnectionSchema,
)
KeepAliveSchema = schemas.StrSchema
keep_alive_parameter = api_client.HeaderParameter(
    name="Keep-Alive",
    style=api_client.ParameterStyle.SIMPLE,
    schema=KeepAliveSchema,
)
SchemaFor200ResponseBodyApplicationJson = AmlScreenAmlResponseSchema
ResponseHeadersFor200 = typing_extensions.TypedDict(
    'ResponseHeadersFor200',
    {
        'Access-Control-Allow-Origin': AccessControlAllowOriginSchema,
        'x-moesif-transaction-id': XMoesifTransactionIdSchema,
        'service': ServiceSchema,
        'product': ProductSchema,
        'price': PriceSchema,
        'Content-Length': ContentLengthSchema,
        'ETag': ETagSchema,
        'Vary': VarySchema,
        'Date': DateSchema,
        'Connection': ConnectionSchema,
        'Keep-Alive': KeepAliveSchema,
    }
)


@dataclass
class ApiResponseFor200(api_client.ApiResponse):
    body: AmlScreenAmlResponse


@dataclass
class ApiResponseFor200Async(api_client.AsyncApiResponse):
    body: AmlScreenAmlResponse


_response_for_200 = api_client.OpenApiResponse(
    response_cls=ApiResponseFor200,
    response_cls_async=ApiResponseFor200Async,
    content={
        'application/json': api_client.MediaType(
            schema=SchemaFor200ResponseBodyApplicationJson),
    },
    headers=[
        access_control_allow_origin_parameter,
        x_moesif_transaction_id_parameter,
        service_parameter,
        product_parameter,
        price_parameter,
        content_length_parameter,
        e_tag_parameter,
        vary_parameter,
        date_parameter,
        connection_parameter,
        keep_alive_parameter,
    ]
)
_status_code_to_response = {
    '200': _response_for_200,
}
_all_accept_content_types = (
    'application/json',
)


class BaseApi(api_client.Api):

    def _screen_aml_mapped_args(
        self,
        first_name: typing.Optional[str] = None,
        last_name: typing.Optional[str] = None,
        date_of_birth: typing.Optional[str] = None,
        name_query_match_threshold: typing.Optional[str] = None,
    ) -> api_client.MappedArgs:
        args: api_client.MappedArgs = api_client.MappedArgs()
        _body = {}
        if first_name is not None:
            _body["first_name"] = first_name
        if last_name is not None:
            _body["last_name"] = last_name
        if date_of_birth is not None:
            _body["date_of_birth"] = date_of_birth
        if name_query_match_threshold is not None:
            _body["name_query_match_threshold"] = name_query_match_threshold
        args.body = _body
        return args

    async def _ascreen_aml_oapg(
        self,
        body: typing.Any = None,
        skip_deserialization: bool = False,
        timeout: typing.Optional[typing.Union[int, typing.Tuple]] = None,
        accept_content_types: typing.Tuple[str] = _all_accept_content_types,
        content_type: str = 'application/json',
        stream: bool = False,
    ) -> typing.Union[
        ApiResponseFor200Async,
        api_client.ApiResponseWithoutDeserializationAsync,
        AsyncGeneratorResponse,
    ]:
        """
        AML Screening
        :param skip_deserialization: If true then api_response.response will be set but
            api_response.body and api_response.headers will not be deserialized into schema
            class instances
        """
        used_path = path.value
    
        _headers = HTTPHeaderDict()
        # TODO add cookie handling
        if accept_content_types:
            for accept_content_type in accept_content_types:
                _headers.add('Accept', accept_content_type)
        method = 'post'.upper()
        _headers.add('Content-Type', content_type)
    
        if body is schemas.unset:
            raise exceptions.ApiValueError(
                'The required body parameter has an invalid value of: unset. Set a valid value instead')
        _fields = None
        _body = None
        request_before_hook(
            resource_path=used_path,
            method=method,
            configuration=self.api_client.configuration,
            body=body,
            auth_settings=_auth,
            headers=_headers,
        )
        serialized_data = request_body_aml_screen_aml_request.serialize(body, content_type)
        if 'fields' in serialized_data:
            _fields = serialized_data['fields']
        elif 'body' in serialized_data:
            _body = serialized_data['body']
    
        response = await self.api_client.async_call_api(
            resource_path=used_path,
            method=method,
            headers=_headers,
            fields=_fields,
            serialized_body=_body,
            body=body,
            auth_settings=_auth,
            timeout=timeout,
        )
    
        if stream:
            if not 200 <= response.http_response.status <= 299:
                body = (await response.http_response.content.read()).decode("utf-8")
                raise exceptions.ApiStreamingException(
                    status=response.http_response.status,
                    reason=response.http_response.reason,
                    body=body,
                )
    
            async def stream_iterator():
                """
                iterates over response.http_response.content and closes connection once iteration has finished
                """
                async for line in response.http_response.content:
                    if line == b'\r\n':
                        continue
                    yield line
                response.http_response.close()
                await response.session.close()
            return AsyncGeneratorResponse(
                content=stream_iterator(),
                headers=response.http_response.headers,
                status=response.http_response.status,
                response=response.http_response
            )
    
        response_for_status = _status_code_to_response.get(str(response.http_response.status))
        if response_for_status:
            api_response = await response_for_status.deserialize_async(
                                                    response,
                                                    self.api_client.configuration,
                                                    skip_deserialization=skip_deserialization
                                                )
        else:
            # If response data is JSON then deserialize for SDK consumer convenience
            is_json = api_client.JSONDetector._content_type_is_json(response.http_response.headers.get('Content-Type', ''))
            api_response = api_client.ApiResponseWithoutDeserializationAsync(
                body=await response.http_response.json() if is_json else await response.http_response.text(),
                response=response.http_response,
                round_trip_time=response.round_trip_time,
                status=response.http_response.status,
                headers=response.http_response.headers,
            )
    
        if not 200 <= api_response.status <= 299:
            raise exceptions.ApiException(api_response=api_response)
    
        # cleanup session / response
        response.http_response.close()
        await response.session.close()
    
        return api_response


    def _screen_aml_oapg(
        self,
        body: typing.Any = None,
        skip_deserialization: bool = False,
        timeout: typing.Optional[typing.Union[int, typing.Tuple]] = None,
        accept_content_types: typing.Tuple[str] = _all_accept_content_types,
        content_type: str = 'application/json',
        stream: bool = False,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        """
        AML Screening
        :param skip_deserialization: If true then api_response.response will be set but
            api_response.body and api_response.headers will not be deserialized into schema
            class instances
        """
        used_path = path.value
    
        _headers = HTTPHeaderDict()
        # TODO add cookie handling
        if accept_content_types:
            for accept_content_type in accept_content_types:
                _headers.add('Accept', accept_content_type)
        method = 'post'.upper()
        _headers.add('Content-Type', content_type)
    
        if body is schemas.unset:
            raise exceptions.ApiValueError(
                'The required body parameter has an invalid value of: unset. Set a valid value instead')
        _fields = None
        _body = None
        request_before_hook(
            resource_path=used_path,
            method=method,
            configuration=self.api_client.configuration,
            body=body,
            auth_settings=_auth,
            headers=_headers,
        )
        serialized_data = request_body_aml_screen_aml_request.serialize(body, content_type)
        if 'fields' in serialized_data:
            _fields = serialized_data['fields']
        elif 'body' in serialized_data:
            _body = serialized_data['body']
    
        response = self.api_client.call_api(
            resource_path=used_path,
            method=method,
            headers=_headers,
            fields=_fields,
            serialized_body=_body,
            body=body,
            auth_settings=_auth,
            timeout=timeout,
        )
    
        response_for_status = _status_code_to_response.get(str(response.http_response.status))
        if response_for_status:
            api_response = response_for_status.deserialize(
                                                    response,
                                                    self.api_client.configuration,
                                                    skip_deserialization=skip_deserialization
                                                )
        else:
            # If response data is JSON then deserialize for SDK consumer convenience
            is_json = api_client.JSONDetector._content_type_is_json(response.http_response.headers.get('Content-Type', ''))
            api_response = api_client.ApiResponseWithoutDeserialization(
                body=json.loads(response.http_response.data) if is_json else response.http_response.data,
                response=response.http_response,
                round_trip_time=response.round_trip_time,
                status=response.http_response.status,
                headers=response.http_response.headers,
            )
    
        if not 200 <= api_response.status <= 299:
            raise exceptions.ApiException(api_response=api_response)
    
        return api_response


class ScreenAml(BaseApi):
    # this class is used by api classes that refer to endpoints with operationId fn names

    async def ascreen_aml(
        self,
        first_name: typing.Optional[str] = None,
        last_name: typing.Optional[str] = None,
        date_of_birth: typing.Optional[str] = None,
        name_query_match_threshold: typing.Optional[str] = None,
    ) -> typing.Union[
        ApiResponseFor200Async,
        api_client.ApiResponseWithoutDeserializationAsync,
        AsyncGeneratorResponse,
    ]:
        args = self._screen_aml_mapped_args(
            first_name=first_name,
            last_name=last_name,
            date_of_birth=date_of_birth,
            name_query_match_threshold=name_query_match_threshold,
        )
        return await self._ascreen_aml_oapg(
            body=args.body,
        )
    
    def screen_aml(
        self,
        first_name: typing.Optional[str] = None,
        last_name: typing.Optional[str] = None,
        date_of_birth: typing.Optional[str] = None,
        name_query_match_threshold: typing.Optional[str] = None,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        args = self._screen_aml_mapped_args(
            first_name=first_name,
            last_name=last_name,
            date_of_birth=date_of_birth,
            name_query_match_threshold=name_query_match_threshold,
        )
        return self._screen_aml_oapg(
            body=args.body,
        )

class ApiForpost(BaseApi):
    # this class is used by api classes that refer to endpoints by path and http method names

    async def apost(
        self,
        first_name: typing.Optional[str] = None,
        last_name: typing.Optional[str] = None,
        date_of_birth: typing.Optional[str] = None,
        name_query_match_threshold: typing.Optional[str] = None,
    ) -> typing.Union[
        ApiResponseFor200Async,
        api_client.ApiResponseWithoutDeserializationAsync,
        AsyncGeneratorResponse,
    ]:
        args = self._screen_aml_mapped_args(
            first_name=first_name,
            last_name=last_name,
            date_of_birth=date_of_birth,
            name_query_match_threshold=name_query_match_threshold,
        )
        return await self._ascreen_aml_oapg(
            body=args.body,
        )
    
    def post(
        self,
        first_name: typing.Optional[str] = None,
        last_name: typing.Optional[str] = None,
        date_of_birth: typing.Optional[str] = None,
        name_query_match_threshold: typing.Optional[str] = None,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        args = self._screen_aml_mapped_args(
            first_name=first_name,
            last_name=last_name,
            date_of_birth=date_of_birth,
            name_query_match_threshold=name_query_match_threshold,
        )
        return self._screen_aml_oapg(
            body=args.body,
        )

